// SetupGraphFrame.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SetupGraphFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupGraphFrame _CAO


CSetupGraphFrame::CSetupGraphFrame(CGraphFrameArray *pframearray, CWnd* pParent /*=NULL*/)
	: CDialog(CSetupGraphFrame::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupGraphFrame)
	m_X0 = 0.0;
	m_X1 = 0.0;
	m_Y0 = 0.0;
	m_Y1 = 0.0;
	m_bClipGraphFrame = false;
	//}}AFX_DATA_INIT
	m_pFrameArray = pframearray;
	m_pFrame = pframearray->GetGraphFrame(0);
}


void CSetupGraphFrame::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupGraphFrame)
	DDX_Text(pDX, IDC_X0EDIT, m_X0);
	DDX_Text(pDX, IDC_X1EDIT, m_X1);
	DDX_Text(pDX, IDC_Y0EDIT, m_Y0);
	DDX_Text(pDX, IDC_Y1EDIT, m_Y1);
	DDX_Check(pDX, IDC_CLIPGRAPHFRAMECHECK, m_bClipGraphFrame);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupGraphFrame, CDialog)
	//{{AFX_MSG_MAP(CSetupGraphFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupGraphFrame bZ[W nh

BOOL CSetupGraphFrame::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if(m_pFrame)
	{
		m_X0 = m_pFrame->GraphPosX0();
		m_X1 = m_pFrame->GraphPosX1();
		m_Y0 = m_pFrame->GraphPosY0();
		m_Y1 = m_pFrame->GraphPosY1();
	}
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSetupGraphFrame::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData(TRUE);
	if(m_pFrame)
	{
		m_pFrame->SetGraphPos(m_X0, m_Y0, m_X1, m_Y1);
	}
	
	CDialog::OnOK();
}
