#============================================================
# Lockinamp7265
#============================================================
package Lockinamp7265;
use Device::DeviceObject;
@ISA = qw(DeviceObject);

#JTu[`
@EXPORT = qw();

use strict;
use Deps;

#============================================================
#@RXgN^AfXgN^
#============================================================
BEGIN { }

sub new
{
	my ($module, @args) = @_;
	my $this = {};
	bless $this;
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->Finish();
}


#============================================================
#@ϐ擾֐
#============================================================
sub GetFunctions { return "|ACVMeasure|"; }

#============================================================
#@ʊ֐
#============================================================

sub Initialize
{
	my ($this) = @_;
}


sub Finish
{
	my ($this) = @_;
}


sub AutoOffset
{
	my ($this) = @_;
	$this->print('AXO' . "\r\n");
}


sub GetId
{
	my ($this) = @_;
	$this->print('ID.?' . "\r\n");
	return $this->read();
}


sub GetX
{
	my ($this) = @_;
	$this->print('X.' . "\r\n");
	return $this->read();
}


sub GetY
{
	my ($this) = @_;
	$this->print('Y.' . "\r\n");
	return $this->read();
}


sub GetFrequency
{
	my ($this) = @_;
	$this->print('FRQ.' . "\r\n");
	return $this->read();
}


sub SetAutoPhase
{
	my ($this) = @_;
	$this->print("AQN\r\n");
	my $ReturnStr= $this->read();
    return $ReturnStr;
}


sub Measure
{
	my ($this) = @_;
	$this->print("X.\r\n");
	my $ReturnStr = $this->read();
	return $ReturnStr;
}





1;