import numpy as np
from numpy import sin, cos, tan, pi
import csv
import sys
from pprint import pprint


from tklib.tkobject import tkObject
from tklib.tkcrystal.tkatomsiteobject import tkAtomSiteObject
from tklib.tksci.tksci import a0, torad, todeg, Round
import tklib.tkre



#=====================================
# Space group class
#=====================================

class tkAtomSite(tkAtomSiteObject):
    def __init__(self, label = None, name = '', charge = None, pos = [], occ = 1.0,
            m = 1, ws = None, hydrogen = None, **args):
        super(tkAtomSite, self).__init__(label, name, pos, occ, m, ws, hydrogen, **args)
        self.update(**args)

    def __del__(self):
        super(tkAtomSite, self).__del__()

    def __str__(self):
        return self.ClassPath()
