// SelectDataDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SelectDataDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectDataDialog _CAO


CSelectDataDialog::CSelectDataDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectDataDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectDataDialog)
	m_DataLabel = _T("");
	m_Data = -1;
	//}}AFX_DATA_INIT
	m_pGraphFrame = NULL;
	m_pGraphFrameArray = NULL;
	m_pGraphDataArray = NULL;
	m_nString = 0;
}

CSelectDataDialog::CSelectDataDialog(CGraphFrame *pframe, CWnd* pParent /*=NULL*/)
	: CDialog(CSelectDataDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectDataDialog)
	m_DataLabel = _T("");
	m_Data = -1;
	//}}AFX_DATA_INIT
	m_pGraphFrame = pframe;
	m_pGraphFrameArray = NULL;
	m_pGraphDataArray = NULL;
	m_nString = 0;
}

CSelectDataDialog::CSelectDataDialog(CGraphFrameArray *pframearray, CWnd* pParent /*=NULL*/)
	: CDialog(CSelectDataDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectDataDialog)
	m_DataLabel = _T("");
	m_Data = -1;
	//}}AFX_DATA_INIT
	m_pGraphFrame = NULL;
	m_pGraphFrameArray = pframearray;
	m_pGraphDataArray = NULL;
	m_nString = 0;
}

CSelectDataDialog::CSelectDataDialog(CGraphDataArray *pdataarray, CWnd* pParent /*=NULL*/)
	: CDialog(CSelectDataDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectDataDialog)
	m_DataLabel = _T("");
	m_Data = -1;
	//}}AFX_DATA_INIT
	m_pGraphFrame = NULL;
	m_pGraphFrameArray = NULL;
	m_pGraphDataArray = pdataarray;
	m_nString = 0;
}

void CSelectDataDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectDataDialog)
	DDX_Control(pDX, IDC_DATALIST, m_DataList);
	DDX_Text(pDX, IDC_DATALABELSTATIC, m_DataLabel);
	DDX_LBIndex(pDX, IDC_DATALIST, m_Data);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectDataDialog, CDialog)
	//{{AFX_MSG_MAP(CSelectDataDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectDataDialog bZ[W nh

BOOL CSelectDataDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	if(m_pGraphFrame)
	{
		m_DataLabel = "Datum in Frame";
		for(int i = 0 ; i < m_pGraphFrame->nGraphData() ; i++)
		{
			CGraphData *pData = m_pGraphFrame->GetGraphData(i);
			if(pData == NULL) continue;
			char str[256];
			sprintf(str, "Dat%d: %s", i, (LPCSTR)(pData->Comment()));
			m_DataList.AddString(str);
		}
	}
	if(m_pGraphFrameArray)
	{
		m_DataLabel = "Datum in FrameArray";
		for(int i = 0 ; i < m_pGraphFrameArray->nGraphFrame() ; i++)
		{
			CGraphFrame *pFrame = m_pGraphFrameArray->GetGraphFrame(i);
			if(pFrame == NULL) continue;
			for(int j = 0 ; j < pFrame->nGraphData() ; j++)
			{
				CGraphData *pData = pFrame->GetGraphData(j);
				if(pData == NULL) continue;
				char str[256];
				sprintf(str, "Frm:%d Dat%d: %s", i, j, (LPCSTR)(pData->Comment()));
				m_DataList.AddString(str);
			}
		}
	}
	if(m_pGraphDataArray)
	{
		m_DataLabel = "Datum in DataArray";
		for(int i = 0 ; i < m_pGraphDataArray->nGraphData() ; i++)
		{
			CGraphData *pData = m_pGraphDataArray->GetGraphData(i);
			if(pData == NULL) continue;
			char str[256];
			sprintf(str, "Dat%d: %s", i, (LPCSTR)(pData->Comment()));
			m_DataList.AddString(str);
		}
	}
	for(int i = 0 ; i < m_nString ; i++)
		m_DataList.AddString(m_String[i]);

	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSelectDataDialog::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData(TRUE);
	m_SelectedData = m_DataList.GetCurSel();

	CDialog::OnOK();
}

int CSelectDataDialog::DoModal() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	int ret = CDialog::DoModal();
	if(ret == IDCANCEL) return -1;
	if(m_SelectedData == LB_ERR) return -2;
	return m_SelectedData;
}

int CSelectDataDialog::SetDataLabel(LPCSTR str)
{
	m_DataLabel = str;
//	UpdateData(FALSE);
	return 0;
}

int CSelectDataDialog::AddList(LPCSTR str)
{
	if(m_nString >= 49) return m_nString;
	m_String[m_nString] = str;
	m_nString++;
//	m_DataList.AddString(str);
	return 0;
}
